Subject: Re: [NFS] [PATCH][RFC] use completions instead of sleep_on for rpciod

From: Greg Banks <[email-masked]>
Date: Tue, 10 Feb 2004 12:52:18 +1100

Olaf Kirch wrote:
> 
> [...] The code in fs/nfs/unlink.c is probably also racy
> without BKL.

I had cause to poke around there recently, and it's *definitely* racy
without BKL.  That file would benefit from several modernisations:

1.  move the list of nfs_unlinkdata from a global to a field in nfs_server

2.  add a lock in nfs_server for it instead of implicit BKL in
    nfs_complete_unlink, nfs_async_unlink, nfs_put_unlinkdata

3.  use proper list.h lists

> So if you remove the sunrpc BKL be prepared for lots and lots
> of bug reports :)

Yes but it's worth doing, especially serverside.

Greg.
-- 
Greg Banks, R&D Software Engineer, SGI Australian Software Group.
I don't speak for SGI.